/*

        Maken Noppa

 Juha Niinikoski 11.11.2003

    Microchip 12CE518

*/

#include <pic.h>

//	__CONFIG(INTRC&MCLREN&WDTDIS);		// Prosessorin tila
	__CONFIG(INTRC&MCLRDIS&WDTDIS);		// Prosessorin tila

const char score[6] = {0x02, 0x04, 0x03, 0x14, 0x16, 0x15};	// Nopan silmtaulu
const char roll[2] = {0x04, 0x10};		// Arvonta kuvio
const char id[] ={"Maken noppa 11.11.2003"};

char arpa;					// Tm on arpakoneen ydin
char disp;					// Nytettv numero
char idx;					// Arvonta kuvio

#define NAPPI GP3				// Arvontanappi

// Apuohjelmat

void delay256us(unsigned char dly)			// n * 256us viive
	{
	GP5 = 1;
	TMR0 = 128 - dly;
	while((TMR0 & 0x80) == 0)		// 128 * 256 us = 32ms
		;
	GP5 = 0;
	}

void arvo(void)					// Arvotaan numero
	{
	idx++;
	idx = idx & 1;				// Arvonta kuvio indexi 1 to 2
	GPIO = roll[idx];			// Pyrit arvonta kuviota

	delay256us(128);			// 100ms viive
	delay256us(128);
	delay256us(128);
	delay256us(128);
	GPIO = 0;				// LEDit pois
	disp = arpa;				// Arpa on heitetty
	}

// Pohjelma

void main(void)
	{
char x;
	TRIS = 0x08;				// GP3 = input, all other = outputs
	OPTION = 0xD7;				// GP2 = output, internal clock/256  for timer

	for(;;)
		{
		arpa++;				// Arvo numeroa
		if(arpa > 5)
			arpa = 0;		// Score indexi 0 to 5

		while(NAPPI == 0)		// Arvonta kieputus
			arvo();

		GPIO = score[disp];		// Nyt numero
		}

	}
